package com.qzing.ime.abnl;

import com.qzing.ime.framework.dto.BaseBatchExtraResponse;
import com.qzing.ime.framework.dto.BaseBatchResponse;
import io.swagger.annotations.ApiModel;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.List;

/**
 * @author: yuzhao
 * @create: 2021-11-02
 **/
@Setter
@Getter
@NoArgsConstructor
@AllArgsConstructor
@ApiModel("设备基础输出参数")
public class BaseAbnlResponse extends BaseBatchExtraResponse {
    private Long gid;
    private String code;
    private String equipCode;
    private String name;
    private String message;

    public BaseAbnlResponse(Long gid, String code, String equipCode, String name, String message, Long successTotal,  List<String> errorData,  List<BaseBatchResponse> responseDtls) {
        super(null,successTotal,errorData,responseDtls);
        this.gid = gid;
        this.code = code;
        this.equipCode  = equipCode;
        this.name = name;
        this.message  = message;
    }


    public static BaseAbnlResponse success(Long gid, String equipCode, String name, String message){
        return new BaseAbnlResponse(gid,"0000",equipCode,name,message);
    }

    public static BaseAbnlResponse success(Long gid, String equipCode, String message){
        return new BaseAbnlResponse(gid,"0000",equipCode,null,message);
    }

    public static BaseAbnlResponse success(String equipCode, String message){
        return new BaseAbnlResponse(null,"0000",equipCode,null,message);
    }

    public static BaseAbnlResponse success(Long gid, String message){
        return new BaseAbnlResponse(gid,"0000",null,null,message);
    }

    public static BaseAbnlResponse success(String message){
        return new BaseAbnlResponse(null,"0000",null,null,message);
    }

    public static BaseAbnlResponse error(Long gid, String equipCode, String name, String message){
        return new BaseAbnlResponse(gid,"10000",equipCode,name,message);
    }

    public static BaseAbnlResponse error(Long gid, String equipCode, String message){
        return new BaseAbnlResponse(gid,"10000",equipCode,null,message);
    }

    public static BaseAbnlResponse error(String equipCode, String message){
        return new BaseAbnlResponse(null,"10000",equipCode,null,message);
    }

    public static BaseAbnlResponse error(Long gid, String message){
        return new BaseAbnlResponse(gid,"10000",null,null,message);
    }

    public static BaseAbnlResponse error(String message){
        return new BaseAbnlResponse(null,"10000",null,null,message);
    }

    public static BaseAbnlResponse successBatch(Long successTotal, List<String> errorData, List<BaseBatchResponse> responseDtls, String message){
        return new BaseAbnlResponse(null,"0000",null,null,message,successTotal,errorData,responseDtls);
    }
}
