package com.qzing.ime.abnl.abnlevent.api;

import com.qzing.ieep.data.common.RestResponse;
import com.qzing.ime.abnl.BaseAbnlRequest;
import com.qzing.ime.abnl.BaseAbnlResponse;
import com.qzing.ime.abnl.BaseBatchAbnlRequest;
import com.qzing.ime.abnl.abnlevent.model.request.*;
import com.qzing.ime.framework.feign.ImeBaseFeignApi;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Map;

/**
 * Created by chenyapeng on 2021/9/28 14:26
 */
@FeignClient("${ime.abnl}/abnl/abnlevent")
public interface AbnlEventFeignClient extends ImeBaseFeignApi<AbnlEventCreateRequest, AbnlEventUpdateRequest> {


    @ApiOperation("异常事件创建")
    @PostMapping({"/save"})
    BaseAbnlResponse createAbnlEvent(@RequestBody AbnlEventCreateRequest request);

    @ApiOperation("异常事件更新")
    @PostMapping({"/update"})
    BaseAbnlResponse updateAbnlEvent(@RequestBody AbnlEventUpdateRequest  request);

    @ApiOperation("异常事件开始响应")
    @PostMapping({"/startrespond"})
    BaseAbnlResponse startRespond(@RequestBody BaseAbnlRequest request);

    @ApiOperation("异常事件完成响应")
    @PostMapping({"/finishrespond"})
    BaseAbnlResponse finishRespond(@RequestBody AbnlEventFinishRespondRequest request);

    @ApiOperation("异常事件完成响应")
    @PostMapping({"/close"})
    BaseAbnlResponse closeAbnlEvent(@RequestBody AbnlEventCloseRequest request);

    @ApiOperation("异常事件删除")
    @PostMapping({"/delete"})
    RestResponse deleteAbnlEvent(@RequestBody BaseBatchAbnlRequest request);

    @ApiOperation("异常事件开始处置")
    @PostMapping({"/starthandle"})
    BaseAbnlResponse starthandleAbnlEvent(@RequestBody AbnlEventStartHandleRequest request);

    @ApiOperation("异常事件完成处置")
    @PostMapping({"/finishhandle"})
    RestResponse finishhandleAbnlEvent(@RequestBody AbnlEventFinishHandleRequest request);


    @ApiOperation("异常事件发送消息")
    @PostMapping({"/sendmessage"})
    void sendmessageAbnlEvent(@RequestBody AbnlRepairTaskRequest request);




    @ApiOperation("设备异常非计划性停机时长")
    @PostMapping({"/unplannedtime"})
    RestResponse<Map<String, Long>> unPlannedTime(@RequestBody List<String> equipCodes);

    @ApiOperation("设备异常非计划性停机时长(设备异常)")
    @PostMapping("getEquipAbnlData")
    RestResponse getEquipAbnlData(@RequestBody EquipAbnlDataRequest request);

    @ApiOperation("设备异常非计划性停机时长(前一周)")
    @PostMapping("getUnplannedStopData")
    RestResponse getUnplannedStopData(@RequestBody EquipAbnlDataRequest request);


    @ApiOperation("设备，质量，生产异常")
    @PostMapping("getAbnlException")
    RestResponse getAbnlException(@RequestParam("workCenterCode") String  workCenterCode);

    @ApiOperation("按作业批次或批次生产单查询异常事件")
    @PostMapping("getAbnlList")
    RestResponse getAbnlList(@RequestBody Map<String,String> abnlParam);

    @ApiOperation("异常事件逾期响应通知")
    @PostMapping({"/replyTimeOut"})
    RestResponse abnlEventReplyTimeOut();

    @ApiOperation("异常事件逾期处置通知")
    @PostMapping({"/handleTimeOut"})
    RestResponse abnlEventHandleTimeOut();

}
