package com.qzing.ime.abnl.earlywarningnotice.api;

import com.qzing.ieep.data.common.RestResponse;
import com.qzing.ime.abnl.earlywarningnotice.model.request.EarlyWarningNoticeCreateRequest;
import com.qzing.ime.abnl.earlywarningnotice.model.request.EarlyWarningNoticeUpdateRequest;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * @author DWJ
 */
@FeignClient("${ime.abnl}/abnl/earlyWarningNotice")
public interface EarlyWarningNoticeClient {

    /**
     * 创建
     */
    @PostMapping("/create")
    RestResponse create(@RequestBody EarlyWarningNoticeCreateRequest request);

    /**
     * 修改
     */
    @PostMapping("/modify")
    RestResponse modify(@RequestBody EarlyWarningNoticeUpdateRequest request);

    /**
     * 删除
     */
    @PostMapping("/delete")
    RestResponse delete(@RequestBody List<Long> gids);

    /**
     * 启用/停用
     */
    @PostMapping("/enable")
    RestResponse enable(@RequestBody EarlyWarningNoticeUpdateRequest request);

    /**
     * 根据编码查询信息
     */
    @PostMapping("findByCode")
    RestResponse findByCode(@RequestParam(value = "code") String code);

}
