package com.qzing.ime.abnl.earlywarningnotice.model.request;

import com.qzing.ime.framework.dto.BaseUpdateRequest;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.util.Date;

/**
 * @author DWJ
 */
@Getter
@Setter
@NoArgsConstructor
public class EarlyWarningNoticeUpdateRequest extends BaseUpdateRequest {

    /**
     * 预警类型编码
     */
    private String code;

    /**
     * 预警类型名称
     */
    private String name;

    /**
     * 消息模板编码
     */
    private String msgCode;

    /**
     * 消息模板名称
     */
    private String msgName;

    /**
     * 开始时间
     */
    private Date startTime;

    /**
     * 执行方式（FIXED：固定间隔，DETAIL：明细设置，TIMELY：及时）
     */
    private String detailRateType;

    /**
     * 固定间隔 - 定时执行类型：SECOND：秒，MINUTE：分钟，HOUR：时，DAILY：天
     */
    private String fixedRateType;

    /**
     * 固定间隔 - 定时执行间隔：默认为 0
     */
    private Integer fixedRateValue;

    /**
     * 明细设置 - 执行时间小时数
     */
    private Integer detailHour;

    /**
     * 明细设置 - 执行时间分钟数
     */
    private Integer detailMinute;

    /**
     * 及时类型 - 间隔时长
     */
    private Integer timelyValue;

    /**
     * 及时类型 - 时间单位(分钟、小时)
     */
    private String timelyType;

    /**
     * 结束时间
     */
    private Date endTime;

    /**
     * 备注
     */
    private String remark;

    /**
     * 状态(启用|1,停用|2)
     */
    private String status;

    /**
     * 定时任务id
     */
    private Long jobId;

    /**
     * 预警级别(一般、重要)
     */
    private String noticeLevel;

    /**
     * 一般预警接收角色id
     */
    private String generalRoleId;

    /**
     * 一般预警接收角色编码
     */
    private String generalRoleCode;

    /**
     * 一般预警接收角色名称
     */
    private String generalRoleName;

    /**
     * 重要预警接收角色id
     */
    private String importantRoleId;

    /**
     * 重要预警接收角色编码
     */
    private String importantRoleCode;

    /**
     * 重要预警接收角色名称
     */
    private String importantRoleName;

}
