package com.qzing.ime.abnl.abnlevent.controller;


import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.bean.copier.CopyOptions;
import cn.hutool.core.collection.CollectionUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.github.xiaoymin.knife4j.core.util.CollectionUtils;
import com.qzing.core.sys.api.BillSetServiceClient;
import com.qzing.framework.core.utils.DateUtil;
import com.qzing.ieep.context.CurrentContextHelper;
import com.qzing.ieep.context.IeepApplicationContext;
import com.qzing.ieep.context.UserAuthInfo;
import com.qzing.ieep.data.common.RestResponse;
import com.qzing.ieep.mail.api.MailSenderClient;
import com.qzing.ieep.mvc.util.UserPermissionUtils;
import com.qzing.ieep.notify.client.NotifySenderClient;
import com.qzing.ieep.notify.dto.NotifySenderParam;
import com.qzing.ieep.roleuserworkcenter.client.RoleUserWorkCenterClient;
import com.qzing.ieep.roleuserworkcenter.model.RoleUserWorkCenterRequest;
import com.qzing.ieep.roleuserworkcenter.model.RoleUserWorkCenterResponse;
import com.qzing.ieep.uaa.api.LoginClient;
import com.qzing.ime.abnl.BaseAbnlResponse;
import com.qzing.ime.abnl.JsonUtil;
import com.qzing.ime.abnl.abnlevent.CalendarTest;
import com.qzing.ime.abnl.abnlevent.api.AbnlEventFeignClient;
import com.qzing.ime.abnl.abnlevent.application.AbnlEventAppServiceImpl;
import com.qzing.ime.abnl.abnlevent.application.impl.StdAbnlEventAppService;
import com.qzing.ime.abnl.abnlevent.dao.AbnlEventDao;
import com.qzing.ime.abnl.abnlevent.dao.AbnlExtendDao;
import com.qzing.ime.abnl.abnlevent.entity.AbnlEvent;
import com.qzing.ime.abnl.abnlevent.entity.AbnlExtend;
import com.qzing.ime.abnl.abnlevent.entity.AbnlRecord;
import com.qzing.ime.abnl.abnlevent.model.enums.BusiStatusEnum;
import com.qzing.ime.abnl.abnlevent.model.enums.ProcessRecordEnum;
import com.qzing.ime.abnl.abnlevent.model.request.AbnlEventCloseRequest;
import com.qzing.ime.abnl.abnlevent.model.request.AbnlEventCreateRequest;
import com.qzing.ime.abnl.abnlevent.model.request.EquipAbnlDataRequest;
import com.qzing.ime.abnl.abnluserrelation.dao.AbnlUserRelationDao;
import com.qzing.ime.abnl.abnluserrelation.entity.AbnlUserRelation;
import com.qzing.ime.abnl.abnluserrelation.model.enums.BusiTypeEnum;
import com.qzing.ime.abnl.earlywarningnotice.application.EarlyWarningNoticeService;
import com.qzing.ime.abnl.earlywarningnotice.model.response.EarlyWarningNoticeResponse;
import com.qzing.ime.framework.toolkit.exception.ImeExceptionUtils;
import com.qzing.ime.framework.toolkit.utils.ImeI18NUtils;
import com.qzing.ime.framework.toolkit.utils.ImeLogger;
import com.qzing.md.generic.client.api.DataDictClient;
import com.qzing.md.generic.vo.DataDictVo;
import com.qzing.toolkit.spring.api.QZingController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @author: yuzhao
 * @create: 2021-10-09
 **/
@QZingController(app = "abnl", domain = "abnlevent")
@Api(tags = "异常事件")
public class AbnlEventFeignClientImpl extends StdAbnlEventFeignClient implements AbnlEventFeignClient {
    private ImeLogger imeLogger = ImeLogger.getInstance(StdAbnlEventAppService.class, "al_abnl_event_relation");
    @Autowired
    private AbnlEventAppServiceImpl abnlEventAppService;
    @Autowired
    private AbnlEventDao abnlEventDao;

    @Autowired
    private MailSenderClient mailSenderClient;

    @Autowired
    private BillSetServiceClient billSetServiceClient;

    @Autowired
    private AbnlUserRelationDao abnlUserRelationDao;

    @Autowired
    private AbnlExtendDao abnlExtendDao;
    @Autowired
    private NotifySenderClient notifySenderClient;

    @Autowired
    private EarlyWarningNoticeService earlyWarningNoticeService;

    @Autowired
    private RoleUserWorkCenterClient roleUserWorkCenterClient;

    @Autowired
    private DataDictClient dataDictClient;

    @ApiOperation("异常事件关闭响应")
    @PostMapping({"/close"})
    public BaseAbnlResponse closeAbnlEvent(AbnlEventCloseRequest request) {
        return abnlEventAppService.closeAbnlEvent(request);
    }


    public RestResponse getEquipAbnlData(EquipAbnlDataRequest request) {
        return abnlEventAppService.getEquipAbnlData(request);
    }


    public RestResponse getUnplannedStopData(EquipAbnlDataRequest request) {
        return abnlEventAppService.getUnplannedStopData(request);
    }


    @Override
    @PostMapping({"getAbnlList"})
    public RestResponse getAbnlList(@RequestBody Map<String, String> abnlParam) {
        Map<String, List<AbnlEvent>> abnlMap = abnlEventAppService.getAbnlList(abnlParam);
        return RestResponse.success(JSON.toJSONString(abnlMap));
    }

    @Override
    @ApiOperation("异常事件逾期响应通知")
    @PostMapping({"/replyTimeOut"})
    public RestResponse abnlEventReplyTimeOut() {
        Map<String, Object> params = new HashMap<>();
        params.put("EQ_busiStatus", "TORESPONDED");
        params.put("LT_applyDate", new Date(new Date().getTime() - 30 * 60 * 1000));
        List<AbnlEvent> abnlEventList = abnlEventDao.findAll(params);
        String code = "ime-abnl#/abnl/abnl/abnlevent/replyTimeOut";
        this.abnlEventNotify(abnlEventList, code);
        return RestResponse.success();
    }

    @Override
    @ApiOperation("异常事件逾期处置通知")
    @PostMapping({"/handleTimeOut"})
    public RestResponse abnlEventHandleTimeOut() {
        Map<String, Object> params = new HashMap<>();
        params.put("EQ_busiStatus", "FINISHRESPONSE");
        params.put("LT_startResponseDate", new Date(new Date().getTime() - 30 * 60 * 1000));
        List<AbnlEvent> abnlEventList = abnlEventDao.findAll(params);
        String code = "ime-abnl#/abnl/abnl/abnlevent/handleTimeOut";
        this.abnlEventNotify(abnlEventList, code);
        return RestResponse.success();
    }

    public void abnlEventNotify(List<AbnlEvent> abnlEventList, String code) {
        if (CollectionUtil.isNotEmpty(abnlEventList)) {
            RestResponse restResponse = earlyWarningNoticeService.findByCode(code);
            if (restResponse.isSuccess()) {
                EarlyWarningNoticeResponse earlyWarningNoticeResponse = (EarlyWarningNoticeResponse) restResponse.getData();
                String notifyCode = earlyWarningNoticeResponse.getMsgCode();
                List<String> roleCodeList = new ArrayList<>();
                if ("GENERAL".equals(earlyWarningNoticeResponse.getNoticeLevel())) {
                    roleCodeList = Arrays.asList(earlyWarningNoticeResponse.getGeneralRoleCode().split(","));
                } else if ("IMPORTANT".equals(earlyWarningNoticeResponse.getNoticeLevel())) {
                    roleCodeList = Arrays.asList(earlyWarningNoticeResponse.getImportantRoleCode().split(","));
                }
                for (String roleCode : roleCodeList) {
                    RoleUserWorkCenterRequest roleUserWorkCenterRequest = new RoleUserWorkCenterRequest();
                    roleUserWorkCenterRequest.setRoleCode(roleCode);
                    RestResponse responses = roleUserWorkCenterClient.findByRoleCode(roleUserWorkCenterRequest);
                    if (responses.isSuccess()) {
                        List<RoleUserWorkCenterResponse> responseList = JSONObject.parseArray(responses.getData().toString(), RoleUserWorkCenterResponse.class);
                        for (RoleUserWorkCenterResponse response : responseList) {
                            List<AbnlEvent> notifyAbnlEventList = abnlEventList;
                            if (!"ALL".equals(response.getWorkCenterCode())) {
                                notifyAbnlEventList = abnlEventList.stream().filter(s -> s.getWorkCenterCode() != null && s.getWorkCenterCode().equals(response.getWorkCenterCode())).collect(Collectors.toList());
                            }
                            if (CollectionUtil.isNotEmpty(notifyAbnlEventList)) {
                                Map<String, Object> extraParams = new HashMap<>();
                                extraParams.put("param1", notifyAbnlEventList.get(0).getCode());
                                extraParams.put("param2", this.getDataDictItemName(notifyAbnlEventList.get(0).getType()));
                                extraParams.put("param3", notifyAbnlEventList.get(0).getMainPhenomenonCode());
                                extraParams.put("param4", notifyAbnlEventList.get(notifyAbnlEventList.size() - 1).getCode());
                                extraParams.put("param5", this.getDataDictItemName(notifyAbnlEventList.get(notifyAbnlEventList.size() - 1).getType()));
                                extraParams.put("param6", notifyAbnlEventList.get(notifyAbnlEventList.size() - 1).getMainPhenomenonCode());
                                extraParams.put("param7", notifyAbnlEventList.size());
                                extraParams.put("param8", cn.hutool.core.date.DateUtil.now());
                                NotifySenderParam notifySenderParam = NotifySenderParam.initBuild()
                                        .notifyCode(notifyCode)
                                        .billType("al_abnl_event_relation")
                                        .billId(notifyAbnlEventList.get(0).getGid().toString())
                                        .senderId(1L)
                                        .receiverId(response.getUserId())
                                        .extraParams(extraParams)
                                        .buildForPush();
                                notifySenderClient.send(notifySenderParam);
                            }
                        }
                    }
                }
            }
        }
    }

    public void login() {
        // 模拟内部登录
        RestResponse<?> response = IeepApplicationContext.getBean(LoginClient.class).internalLogin("800", "pc", "admin");
        // 转换数据，获取token
        Map<String, Object> data = response.convertData(Map.class).getData();
        // 用token获取用户信息
        UserAuthInfo userAuthInfo = UserPermissionUtils.getUserAuthInfo(data.get("token").toString());
        // 将用户信息设置到当前上下文
        CurrentContextHelper.get().setUserAuthInfo(userAuthInfo);
        Map<String, String> httpHeaders = new HashMap<>();
        httpHeaders.put("Authorization", data.get("token").toString());
        CurrentContextHelper.get().setHttpHeaders(httpHeaders);
    }

    public String getDataDictItemName(String itemCode) {
        this.login();
        Map<String, Object> params = new HashMap();
        params.put("itemCode", itemCode);
        JSONObject json = new JSONObject(params);
        String jsonParam = json.toString();
        RestResponse response = dataDictClient.getAll(jsonParam);
        String ItemName = "";
        if (response.isSuccess()) {
            List<DataDictVo> startDataDictVos = JSONObject.parseArray(response.getData().toString(), DataDictVo.class);
            ItemName = startDataDictVos.get(0).getItemName();
        }
        return ItemName;
    }

    @Override
    public RestResponse<Map<String, Long>> unPlannedTime(List<String> equipCodes) {


        String firstDayOfMonth = CalendarTest.getFirstDayOfMonth();
        String fisrtDayOfThisWeek = CalendarTest.getFisrtDayOfThisWeek();
        String firstDayOfLastMonth = CalendarTest.getFirstDayOfLastMonth();
        String endDayOfLastMonth = CalendarTest.getEndDayOfLastMonth();
        long totalTime = 0l;
        /**
         * 当天，设备异常完成处置 减去 创建时间
         */
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

        Date cuDate = new Date();
        String format = sdf.format(cuDate);

        Map<String, Object> searchParams = new HashMap<String, Object>();
        //上月
        searchParams.put("EQ_type", "EQUIPEXCP");
        searchParams.put("GE_createTime", firstDayOfLastMonth);
        searchParams.put("LE_createTime", endDayOfLastMonth);
//        searchParams.put("IN_busiStatus", new String[]{"CLOSE", "FINISHHANDLE"});

        List<AbnlEvent> SYabnlEvents = abnlEventDao.findAll(searchParams);
        searchParams.put("GE_createTime", firstDayOfMonth);
        searchParams.put("LE_createTime", format + " 23:59:59");


        List<AbnlEvent> BZabnlEvents = abnlEventDao.findAll(searchParams);
        searchParams.put("GE_createTime", fisrtDayOfThisWeek);


        List<AbnlEvent> DYabnlEvents = abnlEventDao.findAll(searchParams);
        searchParams.put("GE_createTime", format + " 00:00:00");

        List<AbnlEvent> DTabnlEvents = abnlEventDao.findAll(searchParams);
        long syTotalTime = 0l;
        long dyTotalTime = 0l;
        long dtTotalTime = 0l;
        long bzTotalTime = 0l;
        if (CollectionUtil.isNotEmpty(SYabnlEvents)) {

            for (AbnlEvent SYabnlEvent : SYabnlEvents) {
                Calendar createTime = SYabnlEvent.getCreateTime();
                long startTime = createTime.getTime().getTime();
                String context = SYabnlEvent.getAbnlExtend().getContext();
                JSONObject jsonObject = JSONObject.parseObject(context);
                String equipCode = jsonObject.getString("equipCode");
                if (equipCodes.contains(equipCode)) {
                    if (SYabnlEvent.getBusiStatus().equals("CLOSE") || SYabnlEvent.getBusiStatus().equals("FINISHHANDLE")) {
                        Date handleFinishDate = SYabnlEvent.getHandleFinishDate();
                        if (null != handleFinishDate) {
                            long endTime = handleFinishDate.getTime();

                            long l = endTime - startTime;
                            syTotalTime += l;
                        }

                    } else {
                        long ll = new Date().getTime() - startTime;
                        if (ll <= 0l) {
                            ll = 0l;
                        }

                        syTotalTime += ll;
                    }
                }
            }
        }
        if (CollectionUtil.isNotEmpty(DYabnlEvents)) {
            for (AbnlEvent DYabnlEvent : DYabnlEvents) {
                Calendar createTime = DYabnlEvent.getCreateTime();
                long startTime = createTime.getTime().getTime();
                String context = DYabnlEvent.getAbnlExtend().getContext();
                JSONObject jsonObject = JSONObject.parseObject(context);
                String equipCode = jsonObject.getString("equipCode");
                if (DYabnlEvent.getBusiStatus().equals("CLOSE") || DYabnlEvent.getBusiStatus().equals("FINISHHANDLE")) {

                    Date handleFinishDate = DYabnlEvent.getHandleFinishDate();
                    if (null != handleFinishDate) {
                        long endTime = handleFinishDate.getTime();

                        long l = endTime - startTime;
                        dyTotalTime += l;
                    }
                } else {
                    long ll = new Date().getTime() - startTime;
                    if (ll <= 0l) {
                        ll = 0l;
                    }

                    dyTotalTime += ll;
                }


            }
        }
        if (CollectionUtil.isNotEmpty(BZabnlEvents)) {
            for (AbnlEvent BZabnlEvent : BZabnlEvents) {
                Calendar createTime = BZabnlEvent.getCreateTime();
                long startTime = createTime.getTime().getTime();
                String context = BZabnlEvent.getAbnlExtend().getContext();
                JSONObject jsonObject = JSONObject.parseObject(context);
                String equipCode = jsonObject.getString("equipCode");
                if (BZabnlEvent.getBusiStatus().equals("CLOSE") || BZabnlEvent.getBusiStatus().equals("FINISHHANDLE")) {

                    Date handleFinishDate = BZabnlEvent.getHandleFinishDate();
                    if (null != handleFinishDate) {
                        long endTime = handleFinishDate.getTime();

                        long l = endTime - startTime;
                        bzTotalTime += l;
                    }

                } else {
                    long ll = new Date().getTime() - startTime;
                    if (ll <= 0l) {
                        ll = 0l;
                    }

                    bzTotalTime += ll;
                }


            }
        }

        if (CollectionUtil.isNotEmpty(DTabnlEvents)) {
            for (AbnlEvent DTabnlEvent : DTabnlEvents) {
                Calendar createTime = DTabnlEvent.getCreateTime();
                long startTime = createTime.getTime().getTime();
                String context = DTabnlEvent.getAbnlExtend().getContext();
                JSONObject jsonObject = JSONObject.parseObject(context);
                String equipCode = jsonObject.getString("equipCode");
                if (DTabnlEvent.getBusiStatus().equals("CLOSE") || DTabnlEvent.getBusiStatus().equals("FINISHHANDLE")) {

                    Date handleFinishDate = DTabnlEvent.getHandleFinishDate();
                    if (null != handleFinishDate) {
                        long endTime = handleFinishDate.getTime();

                        long l = endTime - startTime;
                        dtTotalTime += l;
                    }
                } else {
                    long ll = new Date().getTime() - startTime;
                    if (ll <= 0l) {
                        ll = 0l;
                    }

                    dtTotalTime += ll;
                }


            }


        }
        Map<String, Long> hashMap = new HashMap<String, Long>();

        hashMap.put("dyTotalTime", dyTotalTime);
        hashMap.put("dtTotalTime", dtTotalTime);
        hashMap.put("syTotalTime", syTotalTime);
        hashMap.put("bzTotalTime", bzTotalTime);
        return RestResponse.success("异常各阶段查询成功！", hashMap);
    }

    @Override
    public RestResponse getAbnlException(String workCenterCode) {
        return abnlEventAppService.getAbnlException(workCenterCode);
    }

    @ApiOperation("异常事件关系创建")
    @PostMapping({"/save"})
    public BaseAbnlResponse createAbnlEvent(AbnlEventCreateRequest request) {
        String code = request.getCode();
        if (StringUtils.isEmpty(request.getCode())) {
            code = this.billSetServiceClient.createNextRunningNum("YCGL");
        }
        List<AbnlEvent> allByCode = this.abnlEventDao.findAllByCode(code);
        ImeExceptionUtils.isTrue(CollectionUtils.isEmpty(allByCode), ImeI18NUtils.getText("abnl_code_is_exists", new Object[]{code}));
        ImeExceptionUtils.isTrue(JsonUtil.isJson(request.getContext()), ImeI18NUtils.getText("context_is_not_json", new Object[]{code}));
        AbnlEvent abnlEvent = new AbnlEvent();
        BeanUtil.copyProperties(request, abnlEvent, CopyOptions.create().ignoreNullValue());
        abnlEvent.setCode(code);
        abnlEvent.setApplyDate(new Date());
        UserAuthInfo info = CurrentContextHelper.getUserAuthInfo();
        abnlEvent.setApplyUserCode(info.getUserCode());
        abnlEvent.setApplyUserName(info.getUserName());
        abnlEvent.setCreateMode("MANUAL");
        if (request.getAllocatedResponseUserCode() == null && request.getAllocatedResponseUserName() == null) {
            List<AbnlUserRelation> allByBusiTypeAndTypeList = this.abnlUserRelationDao.findAllByBusiTypeAndType(BusiTypeEnum.RESPOND.name(), request.getType());
            String userCodes = (String) allByBusiTypeAndTypeList.stream().map((m) -> {
                return m.getUserCode();
            }).collect(Collectors.joining(","));
            String userNames = (String) allByBusiTypeAndTypeList.stream().map((m) -> {
                return m.getUserName();
            }).collect(Collectors.joining(","));
            abnlEvent.setAllocatedResponseUserCode(userCodes);
            abnlEvent.setAllocatedResponseUserName(userNames);
        }
        List<Long> userLists = null;
        if (ObjectUtils.isNotEmpty(request.getAllocatedResponseUserId())) {
            userLists = Arrays.stream(request.getAllocatedResponseUserId())
                    .map(s -> Long.parseLong(s.trim())).collect(Collectors.toList());
        }
        abnlEvent.setBusiStatus(BusiStatusEnum.TORESPONDED.name());
        AbnlExtend abnlExtend = new AbnlExtend();
        abnlExtend.setContext(request.getContext());
        AbnlRecord abnlRecord = new AbnlRecord();
        abnlRecord.setProcessNode(ProcessRecordEnum.TORESPONDED.name());
        abnlRecord.setExcuteDate(new Date());
        abnlRecord.setExcuteUserCode(info.getUserCode());
        abnlRecord.setExcuteUserName(info.getUserName());
        abnlRecord.setRemark(abnlEvent.getApplyRemark());
        abnlRecord.setPlantCode(abnlEvent.getPlantCode());
        abnlRecord.setPlantName(abnlEvent.getPlantName());
        abnlRecord.setCompanyCode(abnlEvent.getCompanyCode());
        abnlRecord.setCompanyName(abnlEvent.getCompanyName());
        List<AbnlRecord> abnlRecordList = new ArrayList();
        abnlRecordList.add(abnlRecord);
        AbnlExtend abnlExtendSave = (AbnlExtend) this.abnlExtendDao.saveAndFlush(abnlExtend);
        abnlEvent.setAbnlRecordList(abnlRecordList);
        abnlEvent.setAbnlExtendGid(abnlExtendSave.getGid());
        AbnlEvent save = (AbnlEvent) this.abnlEventDao.save(abnlEvent);
        this.imeLogger.infoToDb(save.getGid(), save.getCode(), "异常事件保存成功");
        senMessage(abnlEvent, userLists);
        return BaseAbnlResponse.success(save.getGid(), save.getCode(), "异常事件发起成功");
    }

    void senMessage(AbnlEvent abnlEvent, List<Long> userLists) {
        Map<String, Object> extraParams = new HashMap<>();
        extraParams.put("code", abnlEvent.getCode());
        extraParams.put("type", abnlEvent.getType());
        extraParams.put("sendDate", DateUtil.formateDatePatternD(new Date()));
//         List<Long> userLists = new ArrayList<>();// 查找采购
//         userLists.add((1695721949151506432L);
        NotifySenderParam notifySenderParam = NotifySenderParam.initBuild()
                //消息模板编码
                .notifyCode("ABNL_NOTIFY")
                //发送者
                .senderId(1L)
                //单据类型
                .billType(abnlEvent.getType())
                //单据id
                .billId(abnlEvent.getGid() + "")
                //模板额外替换参数
                .extraParams(extraParams)
                //接收人
                .receiver(userLists)
                .buildForPush();
        //发送待办
        boolean send = notifySenderClient.send(notifySenderParam);
    }
}
