package com.qzing.ime.abnl.abnlevent.dao;

import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;
import java.util.Map;

public interface StdAbnlExtendDao extends AbnlExtendDao {


    @Query(nativeQuery = true, value = "SELECT\n" +
            "\tbmOperationGid \n" +
            "FROM\n" +
            "\tmasterdata.b_md_bmoperation_workcenter \n" +
            "WHERE\n" +
            "\tworkCenterGid IN (\n" +
            "\tSELECT\n" +
            "\t\tgid \n" +
            "\tFROM\n" +
            "\t\tmasterdata.b_md_bmwork_center \n" +
            "\tWHERE\n" +
            "\t\tparentGid IN ( SELECT gid FROM masterdata.b_md_bmwork_center WHERE CODE =:workCenterCode ) UNION\n" +
            "\tSELECT\n" +
            "\t\tgid \n" +
            "\tFROM\n" +
            "\t\tmasterdata.b_md_bmwork_center \n" +
            "WHERE\n" +
            "\tCODE =:workCenterCode)")
    List<Long> findOperationGidGidByCode(@Param("workCenterCode") String workCenterCode);


    @Query(nativeQuery = true, value = "SELECT code from masterdata.b_md_bmwork_center where parentCode = :workCenterCode  or  code = :workCenterCode")
    List<String> findWorkCenterCodesByCode(@Param("workCenterCode") String workCenterCode);


    @Query(nativeQuery = true, value = "SELECT\n" +
            "\tdistinct(a.code) as equipCode,a.name as equipName\n" +
            "FROM\n" +
            "\tmasterdata.b_md_bmequip_detail a\n" +
            "\tLEFT JOIN masterdata.b_md_bmequip_require b ON a.equipRequireGid = b.gid\n" +
            "WHERE\n" +
            "\tb.operationGid IN :gidList \n" +
            "\tAND b.operationGid IS NOT NULL")
    List<Map<String, String>> findEquipCodeByGidList(List<Long> gidList);

}
