package com.qzing.ime.abnl.earlywarningnotice.controller;

import com.qzing.ieep.data.common.RestResponse;
import com.qzing.ime.abnl.earlywarningnotice.api.EarlyWarningNoticeClient;
import com.qzing.ime.abnl.earlywarningnotice.application.EarlyWarningNoticeService;
import com.qzing.ime.abnl.earlywarningnotice.model.request.EarlyWarningNoticeCreateRequest;
import com.qzing.ime.abnl.earlywarningnotice.model.request.EarlyWarningNoticeUpdateRequest;
import com.qzing.toolkit.spring.api.QZingController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * @author DWJ
 */
@QZingController(app = "abnl", domain = "earlyWarningNotice")
public class EarlyWarningNoticeClientImpl implements EarlyWarningNoticeClient {

    @Autowired
    private EarlyWarningNoticeService earlyWarningNoticeService;

    /**
     * 创建
     */
    @Override
    @PostMapping("/create")
    public RestResponse create(@RequestBody EarlyWarningNoticeCreateRequest request){
        return earlyWarningNoticeService.create(request);
    }

    /**
     * 修改
     */
    @Override
    @PostMapping("/modify")
    public RestResponse modify(@RequestBody EarlyWarningNoticeUpdateRequest request){
        return earlyWarningNoticeService.modify(request);
    }

    /**
     * 删除
     */
    @Override
    @PostMapping("/delete")
    public RestResponse delete(@RequestBody List<Long> gids){
        return earlyWarningNoticeService.delete(gids);
    }

    /**
     * 启用/停用
     */
    @Override
    @PostMapping("/enable")
    public RestResponse enable(@RequestBody EarlyWarningNoticeUpdateRequest request){
        return earlyWarningNoticeService.enable(request);
    }

    @Override
    @PostMapping("/findByCode")
    public RestResponse findByCode(@RequestParam(value = "code") String code) {
        return earlyWarningNoticeService.findByCode(code);
    }

}
