package com.qzing.framework.query.advance.jpa;

import com.qzing.framework.core.repository.proxy.HuijuRepositoryProxyPostProcessor;
import com.qzing.ieep.context.IeepApplicationContext;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.ListableBeanFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.data.jpa.repository.support.JpaRepositoryFactoryBean;
import org.springframework.data.repository.core.support.RepositoryFactorySupport;
import org.springframework.lang.Nullable;
import org.springframework.util.Assert;

import javax.persistence.EntityManager;

@SuppressWarnings("rawtypes")
public class JpaRepositoryFactoryBeanExt extends JpaRepositoryFactoryBean implements ApplicationContextAware {

    static ApplicationContext context;

    @Nullable
    private HuijuRepositoryProxyPostProcessor huijuRepositoryProxyPostProcessor;

    @SuppressWarnings("unchecked")
    public JpaRepositoryFactoryBeanExt(Class repositoryInterface) {
        super(repositoryInterface);
    }

    @Override
    protected RepositoryFactorySupport createRepositoryFactory(EntityManager entityManager) {
        JpaRepositoryFactoryExt ext = new JpaRepositoryFactoryExt(entityManager);
        if (huijuRepositoryProxyPostProcessor != null) {
            ext.addRepositoryProxyPostProcessor(huijuRepositoryProxyPostProcessor);
        }
        return ext;
    }

    @Override
    public void setBeanFactory(BeanFactory beanFactory) {
        Assert.isInstanceOf(ListableBeanFactory.class, beanFactory);

        super.setBeanFactory(beanFactory);

        ListableBeanFactory listableBeanFactory = (ListableBeanFactory) beanFactory;
        this.huijuRepositoryProxyPostProcessor = new HuijuRepositoryProxyPostProcessor(listableBeanFactory);
    }

    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        context = applicationContext;
        IeepApplicationContext.setApplicationContext(applicationContext);
    }
}
